/*
 * Copyright (C) 2005 The Mir-coders group
 *
 * This file is part of Mir.
 *
 * Mir is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Mir is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Mir; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * In addition, as a special exception, The Mir-coders gives permission to link
 * the code of this program with  any library licensed under the Apache Software License.
 * You must obey the GNU General Public License in all respects for all of the code used
 * other than the above mentioned libraries.  If you modify this file, you may extend this
 * exception to your version of the file, but you are not obligated to do so.
 * If you do not wish to do so, delete this exception statement from your version.
 */
package mir.generator.tal.template;

import java.io.PrintWriter;
import java.util.Map;

import mir.generator.tal.interfaces.TALExpressionParser;
import mir.generator.tal.interfaces.TALLogger;

/**
 * @see <a href="http://dev.zope.org/Wikis/DevSite/Projects/ZPT/TAL%20Specification%201.4">TAL Spec</a>
 */

public class Template {
  private TemplateNode rootNode;
  private TALExpressionParser parser;
  private Map context;

  public Template(TALExpressionParser aParser, TemplateNode aRootNode, Map aTemplateContext) {
    rootNode = aRootNode;
    parser = aParser;
    context = aTemplateContext;
  }

  /** get this template's context */
  public Map getContext() {
    return context;
  }

  public void process(Object aContext, PrintWriter aDestination,
      TALLogger aLogger, TemplateLibrary aLibrary) throws TemplateProcessingException {
    StringBuffer output = new StringBuffer();

    aLogger.debug("Template", "processing rootnode");
    rootNode.process(parser, aContext, output, aLogger, context, aLibrary);
    aLogger.debug("Template", "done processing rootnode");
    aDestination.print(output);
  }

}